#define MAXSEQNUM 600     /* Maximum number of sequences per alignment*/
#define MAXSEQLEN 1500   /* Maximum Sequence Length */
#define MINV -9.9
#define MAXV 9.9

/* aa lookup table to do aa substitution matrix*/
int matrix[24][24] = {
                      {  4, -1, -2, -2,  0, -1, -1,  0, -2, -1, -1, -1, -1, -2, -1,  1,  0, -3, -2,  0, -2, -1 , 0, -4 },
                      { -1,  5,  0, -2, -3,  1,  0, -2,  0, -3, -2,  2, -1, -3, -2, -1, -1, -3, -2, -3, -1,  0 ,-1, -4 },
                      { -2,  0,  6,  1, -3,  0,  0,  0,  1, -3, -3,  0, -2, -3, -2,  1,  0, -4, -2, -3,  3,  0 ,-1, -4 },
                      { -2, -2,  1,  6, -3,  0,  2, -1, -1, -3, -4, -1, -3, -3, -1,  0, -1, -4, -3, -3,  4,  1 ,-1, -4 },
                      {  0, -3, -3, -3,  9, -3, -4, -3, -3, -1, -1, -3, -1, -2, -3, -1, -1, -2, -2, -1, -3, -3 ,-2, -4 },
                      { -1,  1,  0,  0, -3,  5,  2, -2,  0, -3, -2,  1,  0, -3, -1,  0, -1, -2, -1, -2,  0,  3 ,-1, -4 },
                      { -1,  0,  0,  2, -4,  2,  5, -2,  0, -3, -3,  1, -2, -3, -1,  0, -1, -3, -2, -2,  1,  4 ,-1, -4 },
                      {  0, -2,  0, -1, -3, -2, -2,  6, -2, -4, -4, -2, -3, -3, -2,  0, -2, -2, -3, -3, -1, -2 ,-1, -4 },
                      { -2,  0,  1, -1, -3,  0,  0, -2,  8, -3, -3, -1, -2, -1, -2, -1, -2, -2,  2, -3,  0,  0 ,-1, -4 },
                      { -1, -3, -3, -3, -1, -3, -3, -4, -3,  4,  2, -3,  1,  0, -3, -2, -1, -3, -1,  3, -3, -3 ,-1, -4 },
                      { -1, -2, -3, -4, -1, -2, -3, -4, -3,  2,  4, -2,  2,  0, -3, -2, -1, -2, -1,  1, -4, -3 ,-1, -4 },
                      { -1,  2,  0, -1, -3,  1,  1, -2, -1, -3, -2,  5, -1, -3, -1,  0, -1, -3, -2, -2,  0,  1 ,-1, -4 },
                      { -1, -1, -2, -3, -1,  0, -2, -3, -2,  1,  2, -1,  5,  0, -2, -1, -1, -1, -1,  1, -3, -1 ,-1, -4 },
                      { -2, -3, -3, -3, -2, -3, -3, -3, -1,  0,  0, -3,  0,  6, -4, -2, -2,  1,  3, -1, -3, -3 ,-1, -4 },
                      { -1, -2, -2, -1, -3, -1, -1, -2, -2, -3, -3, -1, -2, -4,  7, -1, -1, -4, -3, -2, -2, -1 ,-2, -4 },
                      {  1, -1,  1,  0, -1,  0,  0,  0, -1, -2, -2,  0, -1, -2, -1,  4,  1, -3, -2, -2,  0,  0 , 0, -4 },
                      {  0, -1,  0, -1, -1, -1, -1, -2, -2, -1, -1, -1, -1, -2, -1,  1,  5, -2, -2,  0, -1, -1 , 0, -4 },
                      { -3, -3, -4, -4, -2, -2, -3, -2, -2, -3, -2, -3, -1,  1, -4, -3, -2, 11,  2, -3, -4, -3 ,-2, -4 },
                      { -2, -2, -2, -3, -2, -1, -2, -3,  2, -1, -1, -2, -1,  3, -3, -2, -2,  2,  7, -1, -3, -2 ,-1, -4 },
                      {  0, -3, -3, -3, -1, -2, -2, -3, -3,  3,  1, -2,  1, -1, -2, -2,  0, -3, -1,  4, -3, -2 ,-1, -4 },
                      { -2, -1,  3,  4, -3,  0,  1, -1,  0, -3, -4 , 0, -3, -3, -2,  0, -1, -4, -3, -3,  4,  1 ,-1, -4 },
                      { -1,  0,  0,  1, -3,  3,  4, -2,  0, -3, -3,  1, -1, -3, -1,  0, -1, -3, -2, -2,  1,  4 ,-1, -4 },
                      {  0, -1, -1, -1, -2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -2,  0,  0, -2, -1, -1, -1, -1 ,-1, -4 },
                      { -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4, -4 ,-4,  1 }
};


/* ven diagram from Taylor's paper */
static int ventab[24][10] = {

  {1,0,0,0,0,1,1,0,0,0}, /* Ala  A */
  {1,0,0,0,0,1,0,0,0,0}, /* Cys  C */
  {0,0,1,1,1,1,0,0,0,0}, /* Asp  D */
  {0,0,1,1,1,0,0,0,0,0}, /* Glu  E */
  {1,0,0,0,0,0,0,0,1,0}, /* Phe  F */
  {1,0,0,0,0,1,1,0,0,0}, /* Gly  G */
  {1,1,0,1,1,0,0,0,1,0}, /* His  H */
  {1,0,0,0,0,0,0,1,0,0}, /* Ile  I */
  {1,1,0,1,1,0,0,0,0,0}, /* Lys  K */
  {1,0,0,0,0,0,0,1,0,0}, /* Leu  L */
  {1,0,0,0,0,0,0,0,0,0}, /* Met  M */
  {0,0,0,1,0,1,0,0,0,0}, /* Asn  N */
  {0,0,0,0,0,1,0,0,0,1}, /* Pro  P */
  {0,0,0,1,0,0,0,0,0,0}, /* Gln  Q */
  {0,1,0,1,1,0,0,0,0,0}, /* Arg  R */
  {0,0,0,1,0,1,1,0,0,0}, /* Ser  S */
  {1,0,0,1,0,1,0,0,0,0}, /* Thr  T */
  {1,0,0,0,0,1,0,1,0,0}, /* Val  V */
  {1,0,0,1,0,0,0,0,1,0}, /* Typ  W */
  {1,0,0,1,0,0,0,0,1,0}, /* Tyr  Y */
  {0,0,0,1,0,1,0,0,0,0}, /* Glx  Z */
  {1,1,1,1,1,1,1,1,1,1}, /* Unk  X */
  {0,0,0,1,0,0,0,0,0,0}, /* Asx  B */
  {1,1,1,1,1,1,1,1,1,1}, /* Gap  . */

};


char residues [24] = {'A','C','D','E','F','G','H','I','K','L','M','N','P','Q','R','S','T','V','W','Y','Z','X','B','.'};
char states[3] = {'H','E','C'};
int whichmat = 1;
int nopsi=0;
int nohmm=0;
